/*
    This program calls the "thread functions" as threads,
    that is, they are called concurrently. Notice that this
    program has three threads. The main thread blocks on
    WaitForMultipleObjects() in order to wait for the child
    threads to complete.

    This program passes parameters (by reference) to the threads.
    The pointers to the parameters are on each thread's stack.
    Use a virtual memory mapping program to see where thread stacks
    are placed in virtual memeory.
*/
#include <stdio.h>
#include <windows.h>

// function prototypes
DWORD WINAPI thread1(LPVOID);
DWORD WINAPI thread2(LPVOID);

int main()
{
   HANDLE hthread[2];

   int arg1 = 101;
   int arg2 = 202;

   fprintf(stderr, "Address of arg1 = %d\n", (int)&arg1);
   fprintf(stderr, "Address of arg2 = %d\n\n", (int)&arg2);

   // create the threads
   hthread[0] = CreateThread(NULL, 0, thread1, &arg1, 0, NULL); //should check for errors
   hthread[1] = CreateThread(NULL, 0, thread2, &arg2, 0, NULL);

   // wait for the threads to finish
   WaitForMultipleObjects(2, hthread, TRUE, INFINITE);

   fprintf(stderr, "\nAll done.\n");

   return 0;
}


DWORD WINAPI thread1(LPVOID vargp)  // vargp means "variable (length) argument pointer"
{
   int arg = *((int*)vargp);   // the "void pointer" needs to be cast back into an int pointer

    fprintf(stderr, "hello ");
    Sleep(1000);
    fprintf(stderr, "from thread 1");
    Sleep(1000);
    fprintf(stderr, " with argument %d at location %d!\n", arg, (int)&vargp);

    //while(1) Sleep(1000);  //use this to pause the thread and look at virtual memory

    return 0;
}


DWORD WINAPI thread2(LPVOID vargp)
{
   int arg = *((int*)vargp);

    fprintf(stderr, "HELLO FROM ");
    Sleep(1000);
    fprintf(stderr, "THREAD 2");
    Sleep(1000);
    fprintf(stderr, " WITH ARGUMENT %d AT LOCATION %d?\n", arg, (int)&vargp);

    //while(1) Sleep(1000);  //use this to pause the thread and look at virtual memory

    return 0;
}
